<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class JSMassMailModelExport extends JModel
{

	var $_id = null;
	var $_data = null;

	function __construct()
	{
	  global $mainframe, $option;
		parent::__construct();
    if(JRequest::getVar('layout') != 'xlstable'){
  		$limit		  = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.export.limitstart', 'limitstart', 0, 'int' );

  		$this->setState('limit',      $limit);
  		$this->setState('limitstart', $limitstart);
    }
	}

	/*function &getPost()
	{
	  print_r($_REQUEST);exit;
	}*/

	function &getData()
	{
		// Load the weblink data
		if ($this->_id != 0)
		{
		  $this->_loadData();
			// Initialize some variables
			$user = &JFactory::getUser();
			// Check to see if the category is published
			if (!$this->_data->cat_pub) {
				JError::raiseError( 404, JText::_("Resource Not Found: Category of this filed is not exist.") );
				return;
			}

			// Check whether category access level allows access
			if ($this->_data->cat_access > $user->get('aid', 0) || $this->_data->access > $user->get('aid', 0)) {
				JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
				return;
			}
		}
		else  $this->_initData();

		return $this->_data;
	}

	function getExportableFieldList()
	{
	  $include_type_list = array( "select", "checkbox", "radio", "date", "calendar", "phone", "text", "textarea" );
	  $include_type_list = " f.type IN('" . implode( "','", $include_type_list ) . "') ";

    $query = "SELECT f. * , f.id as field_id, c.title as cat_title"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n      WHERE 1 AND " . $include_type_list
    . "\n   ORDER BY c.ordering, f.ordering"
    ;

    $this->_db->setQuery($query);
		$reportable_field_list = $this->_db->loadObjectList();
		return $reportable_field_list;
	}
	function getFieldValues()
	{
	  $field = JRequest::getVar('_field_');

    $query = "SELECT f.params"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n      WHERE 1 AND f.id = ".$field->field_id
    ;
    $this->_db->setQuery($query);
		$params_str = $this->_db->loadResult();

		$params = new JParameter( $params_str );

		$field_value_list = $params->get('values');
		if($field_value_list){
  		$field_value_list = explode( "\n", str_replace( "\r", "", $field_value_list ) );

  		sort($field_value_list);
		} else {
      return array();
    }
		return $field_value_list;
	}



	function getTotal()
	{
		$post = JRequest::get('hash');

	  $output_field_list = $this->fieldListSubquery( $post );

	  $where_conditions  = '';
	  $where_conditions .= $this->registerDateCondition( $post );
	  $where_conditions .= $this->activeCondition( $post );
	  if($GLOBALS['is_jcs_exist'] && JRequest::getVar('controller') == 'newsletter' && count(JRequest::getVar('subscriptions'))){
	    $where_conditions .= $this->subscriptionCondition( );
	  }

	  $having_conditions = $this->fieldHavingConditions( $post );

	  $query = "SELECT *, ".$output_field_list
    . "\n       FROM #__users AS u"
   	. "\n      WHERE 1 ".$where_conditions
   	. "\n     HAVING 1 ".$having_conditions
    ;

    $this->_db->setQuery($query);
		$userlist = $this->_db->loadObjectList();

		return count($userlist);
	}

	function _buildFieldOrderBy()
	{
		global $mainframe, $option;

		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.fields.filter_order',		'filter_order',		'u.registerDate',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.fields.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		/*if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY category, a.ordering '.$filter_order_Dir;
		} else {*/
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , u.registerDate ';
		/*}*/
		return $orderby;
	}

	function registerDateCondition( & $post )
	{
	  $result  = "";

	  if(!empty($post['date_from'])){
	    $result .= " AND u.registerDate >= '".$post['date_from']."' ";
	  }
	  if(!empty($post['date_to'])){
	    $result .= " AND u.registerDate <= '".$post['date_to']."' ";
	  }

	  return $result;
	}

	function emailConfirmationCondition( & $post )
	{
		if ($post['confirmation']){
			  $strict = $post['confirmation']['strict'];
			  $soft = $post['confirmation']['soft'];
			  $none = $post['confirmation']['none'];
			  $result = null;
		  if($strict){
		    $result = " AND u.activation = '1' ";
		  }
		  if ($soft){
		    $result = " AND (u.activation = '1' OR u.activation = '') ";	  	
		  }
		  if ($none){
		    $result = " AND (u.activation != '1' AND u.activation != '') ";	  	
		  }
		  if ($strict && $soft){
		    $result = " AND (u.activation = '1' OR u.activation = '') ";	  	
		  }
		  if ($strict && $none){
		    $result = " AND (u.activation != '') ";	  	
		  }
		  if ($soft && $none){
		    $result = " AND (u.activation != '1') ";	  	
		  }
		  if ($strict && $soft && $none){
		    $result = null;	  	
		  }
		}
		return $result;
	}

	function groupCondition(&$post)
	{
	  $result = "";
	  if (!empty($post['gid']) && count($post['gid'])>0)
	  {
	    foreach ($post['gid'] as $key => $gid)
	    {
        $result .= " OR u.gid = $gid ";
	    }
	  }
	  return $result;
	}

	function activeCondition( & $post )
	{
	  $result  = "";

	  switch(!empty($post['active_filter'])){
	    case'active':
	      $result .= " AND u.block = 0 ";
	      break;
	    case'blocked':
	      $result .= " AND u.block = 1 ";
	      break;
	    case'both':
	      $result .= "";
	      break;
	  }

	  return $result;
	}

	function getfieldShowList()
	{
	  $include_fields = " f.id IN('" . implode( "','", JRequest::getVar('extended_fields_include') ) . "') ";

    $query = "SELECT f. * , f.id as field_id, c.title as cat_title"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n      WHERE 1 AND " . $include_fields
    . "\n   ORDER BY c.ordering, f.ordering"
    ;
    $this->_db->setQuery($query);
		$fields = $this->_db->loadObjectList();
		return $fields;
	}

  function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
    {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
}
?>