<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');


class JSMassMailModelMain extends JModel
{
	/**
	 * Category ata array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * Category total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Pagination object
	 *
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */
	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit		  = $mainframe->getUserStateFromRequest( $option.'.main.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.main.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit',      $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData()
	{

		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}


		return $this->_data;
	}



	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);

		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}


	function _buildQuery()
	{
		$orderby	= $this->_buildOrderBy();

		$query = '   SELECT c.*, (SELECT COUNT(*) FROM #__jsmassmail_users WHERE `letter_id` = c.id ) AS sent'
		. ' FROM #__jsmassmail_newsletters AS c '
		//. '  GROUP BY c.id '
		. $orderby
		;
		//print $query;exit;
		return $query;
	}

	function _buildOrderBy()
	{
		global $mainframe, $option;

		$filter_order	  	= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order', 'c.createdate');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'DESC');
		/*$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.main.filter_order',		 'filter_order',		 'c.active',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.main.filter_order_Dir', 'filter_order_Dir', 'DESC',		    'word' );*/

		if ($filter_order == 'c.active' ){
			$orderby 	= ' ORDER BY c.active '.$filter_order_Dir;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		}
		return $orderby;
	}

	function saveNewsletter($params=array())
	{

		if (!isset($params['id']))
		{
			$params['id'] = 0;
		}
		if ($params['id'] == 0)
		{
			$params['createdate'] = date("Y-m-d H:i:s ", time());
		}

		$table = &$this->getTable('newsletters', 'JSMassMail');
		$table->load($params['id']);
		$table->bind($params);

		if ($table->store())
		{

			return $table->id;
		}
		else
		{
			return false;
		}

	}

	function remove($id)
	{
		$table = $this->getTable('newsletters', "JSMassMail");
		if (is_array($id))
		{
			foreach ($id as $i) {
				$table->delete($i);
			}
		}
		else
		{
			$table->delete($i);
		}

	}

	function setActive($id, $status)
	{
		$table = $this->getTable("newsletters", "JSMassMail");
		$table->load($id);
		$table->set('active', $status);
		if (!$table->store()){
			return false;
		}
		return true;
	}

	function send($id = 0)
	{
		if ($id==0){
            return false;
        }
		$table = $this->getTable("newsletters", "JSMassMail");
		$table->load($id);
        if ($table->status == 'sending' || $table->status == 'pending'){
            return false;
        }
		if (!$table->datestart || $table->datestart == '0000-00-00 00:00:00'){
			$table->datestart = date("Y-m-d H:i:s", time());
        }
		$table->started = 0;
		$table->status = 'sending';
		return $table->store();
	}
	function stop($id = 0)
	{
		if ($id==0){return false;}
		$table = $this->getTable("users", "JSMassMail");
		$newslt = $this->getTable("newsletters", "JSMassMail");
        $newslt->load($id);
        if ($newslt->status == 'sending' || $newslt->status == 'pending'){
            $newslt->status = '';
            $newslt->total = null;
            $newslt->last_sent = '0000-00-00 00:00:00';
            $newslt->datestart = '0000-00-00 00:00:00';
            $newslt->store();
    		return $table->clearByletter_id($id);
        }
        return false;
	}

	/*function _addUsers($id, $users = array())
	{
		$db = &JFactory::getDBO();
		$total = count($users);
		if (count($users)>0)
		{
			$query = "INSERT INTO #__jsmassmail_users (`user_id`, `letter_id`) VALUES ";
			foreach ($users as $key => $usr)
			{
				if ($key==$total-1)
				{
					$query.= " ( {$usr->id} , $id)";
				}
				else
				{
					$query.= " ( {$usr->id} , $id),";
				}

			}
			$db->setQuery($query);
			$db->query();
		}
	}*/

	function pause($id)
	{
		$table = $this->getTable("newsletters", "JSMassMail");
		$table->load($id);
        if ($table->status == 'sending'){
            $table->status = "pending";
            if ($table->store())
            {
                return true;
            }
        }
		return false;
	}

	function resume($id)
	{
		$table = $this->getTable("newsletters", "JSMassMail");
		$table->load($id);
        if ($table->status == 'pending'){
            $table->status = 'sending';
            if ($table->store())
            {
                return true;

            }
        }
		return false;
	}


}


?>