<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');


class JSMassMailModelNewsletter extends JModel
{
	/**
	 * Category ata array
	 *
	 * @var array
	 */
	var $_letter = null;
	var $_data = null;

	var $_total = null;


	var $_pagination = null;


	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit		  = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.newsletter.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit',      $limit);
		$this->setState('limitstart', $limitstart);
	}

	/**
	 * Method to get weblinks item data
	 *
	 * @access public
	 * @return array
	 */
	function getData()
	{

		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQueryContentList();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	/**
	 * Method to get the total number of weblink items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQueryContentList();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	/**
	 * Method to get a pagination object for the weblinks
	 *
	 * @access public
	 * @return integer
	 */
	function getPagination()
	{
		if (empty($this->_pagination))
    {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function _buildQueryContentList()
	{
		$orderby	= $this->_buildContentOrderBy();

    //$include_category_list = str_replace("\n", ',', JU_NEWS_LETTER_NL_CONTENT);

  	$query = '   SELECT c.*, cc.title as cat_title, s.id as sec_id, s.title as sec_title'
        	. '      FROM #__content AS c '
        	. ' LEFT JOIN #__categories AS cc ON cc.id = c.catid '
        	. ' LEFT JOIN #__sections AS s ON s.id = cc.section '
        	//. '     WHERE c.catid IN ('.$include_category_list.')'
        	. ' WHERE s.id = '.MSML_CORESECTION
        	. '  GROUP BY c.id '
			    . $orderby
		;
    //print $query;exit;
		return $query;
	}

	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.newsletter.filter_order',		 'filter_order',		 'c.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.newsletter.filter_order_Dir', 'filter_order_Dir', '',				    'word' );

		if ($filter_order == 'c.ordering'){
			$orderby 	= ' ORDER BY s.ordering, cc.ordering, c.ordering '.$filter_order_Dir;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , s.ordering, cc.ordering, c.ordering ';
		}
		return $orderby;
	}

	function getContentList()
	{
	  $cats = JRequest::getVar( 'cid', array() );
	  $include_content_list = implode( ',', $cats );
	  $query = '   SELECT c.*'
        	. '      FROM #__content AS c '
        	. ' LEFT JOIN #__categories AS cc ON cc.id = c.catid '
        	. ' LEFT JOIN #__sections AS s ON s.id = cc.section '
        	. '     WHERE c.id IN ('.$include_content_list.')'
        	. '  ORDER BY s.ordering, cc.ordering, c.ordering '
    ;
    return $this->_getList($query);
	}




	function getLetter()
	{


    if (empty($this->_letter))
    {
      $id = JRequest::getVar('id', 0);
      $this->_letter = &JTable::getInstance('Newsletters','JSMassMail');
      //print_R($table);
      $this->_letter->load($id);


    }
    return $this->_letter;
	}
}
?>
